﻿$__author__ = "Shagun Agrawal <shaguna@chelsio.com"
$Global:__version__ = "2.0"

$Global:__t5_cards = @{
    # For internal use only don't modify this.
}

$Global:__t5_parts = @{
}

$Global:__t5_vpd_map = @{
}

$Global:__t5_vpd_revmap = @{
}


$Global:__sys_drive = (Get-ChildItem Env:\SystemDrive).Value

$Global:__vpd_default = @{

        "T580-CR"    = "t580_cr_variable_2133_vpd.bin";
        "T580-LP-CR" = "t580_lp_cr_variable_2133_vpd.bin";
        "T580-SO-CR" = "t580_lp_so_variable_vpd.bin";
}

$Global:__vpd_spider = @{
        
        "T580-CR"    = "t580_cr_spider_variable_2133_vpd.bin";
        "T580-LP-CR" = "t580_lp_cr_spider_variable_2133_vpd.bin";
        "T580-SO-CR" = "t580_lp_so_spider_variable_2133_vpd.bin";
}

$Global:__vpd_qsa = @{
    
        "T580-CR"    = "t580_cr_qsa_variable_2133_vpd.bin";
        "T580-LP-CR" = "t580_lp_cr_qsa_variable_2133_vpd.bin";
        "T580-SO-CR" = "t580_lp_so_qsa_variable_vpd.bin";
}

$Global:__sriov = @{

       "T502-BT"    = "t502_bt_init_gen3_150mhz_Pf4vf.bin";
       "T520-BT"    = "t520_bt_init_gen3_250_820_Pf4vf.bin";
       "T520-CR"    = "t520_cr_init_gen3_250_825_Pf4vf.bin";
       "T520-LL-CR" = "t520_ll_init_gen3_650_1075_Pf4vf.bin";
       "T520-SO"    = "t520_so_init_gen3_250_825_Pf4vf.bin";
       "T522-CR"    = "t522_cr_init_gen3_500mhz_Pf4vf.bin";
       "T540-CR"    = "t540_cr_init_gen3_500_825_Pf4vf.bin";
       "T580-CR"    = "t580_cr_init_gen3_500Mhz_Pf4vf.bin";
       "T580-LP-CR" = "t580_lp_cr_init_gen3_500Mhz_Pf4vf.bin";
       "T580-SO-CR" = "t580_lp_so_init_gen3_500Mhz_Pf4vf.bin";
}

$Global:__default_init = @{
    
       "T502-BT"    = "t502_bt_init_gen3_150mhz.bin";
       "T520-BT"    = "t520_bt_init_gen3_250_820.bin";
       "T520-CR"    = "t520_cr_init_gen3_250_825.bin";
       "T520-LL-CR" = "t520_ll_init_gen3_650_1075.bin";
       "T520-SO"    = "t520_so_init_gen3_250_825.bin";
       "T522-CR"    = "t522_cr_init_gen3_500mhz.bin";
       "T540-CR"    = "t540_cr_init_gen3_500_825.bin";
       "T580-CR"    = "t580_cr_init_gen3_500Mhz.bin";
       "T580-LP-CR" = "t580_lp_cr_init_gen3_500Mhz.bin";
       "T580-SO-CR" = "t580_lp_so_init_gen3_500Mhz.bin";
}

$Global:device_map = @{

        # Maps device ids to human readable names.

        "B000"    = "Bypass Mode";
        "5400"    = "T580-dbg";
        "5401"    = "T520-CR";
        "5402"    = "T522-CR";
        "5403"    = "T540-CR";
        "5404"    = "T520-BCH";
        "5405"    = "T540-BCH";
        "5406"    = "T540-CH";
        "5407"    = "T520-SO";
        "5408"    = "T520-CX";
        "5409"    = "T520-BT";
        "540A"    = "T504-BT";
        "540B"    = "B520-SR";
        "540C"    = "B504-BT";
        "540D"    = "T580-CR";
        "540E"    = "T540-LP-CR";
        "540F"    = "Amsterdam";

        "5410"    = "T580-LP-CR";
        "5411"    = "T520-LL-CR";
        "5412"    = "T560-CR";
        "5413"    = "T580-CHR";
        "5414"    = "T580-SO-CR";
        "5415"    = "T502-BT";

        "5480"    = "SECUI";
        "5481"    = "SECUI-LL";
        "5482"    = "SECUI-1G";

        "5483"    = "HUAWEI-T540-CANCELED";
        "5484"    = "HUAWEI-T580-CALCELED";
        "5485"    = "HUAWEI-3XT580-CANCELED";
        "5486"    = "HUAWEI-2XT580";
        "5487"    = "Dell Harpoon";
        "5488"    = "Xalyo T570";
        "5489"    = "KTFN T520";
        "5490"    = "KTFN T540";

        "5491"    = "Huawei T522 LOM";
        "5492"    = "Datawise T520-XFI";
        
        <#
        "5800"    = "";
        "5801"    = "";
        "5802"    = "";
        "5803"    = "";
        "5804"    = "";
        "5805"    = "";
        "5806"    = "";
        "5807"    = "";
        "5808"    = "";
        "5809"    = "";
        "580A"    = "";
        "580B"    = "";
        "580C"    = "";
        "580D"    = "";
        "580E"    = "";
        "5810"    = "";
        "5811"    = "";
        "5812"    = "";
        "5813"    = "";
        "5814"    = "";
        "5815"    = "";
        "5880"    = "";
        "5881"    = "";
        "5883"    = "";
        "5884"    = "";
        "5885"    = "";
        "5886"    = "";
        "5887"    = "";
        "5888"    = "";
        "5889"    = "";
        "5890"    = "";
        #>
        
}

function is_cxgbtool_present ()
{
        return Test-Path C:\Windows\System32\cxgbtool.exe
}


function get_t5_count ()
{
        if ((Test-Path "HKLM:\SYSTEM\CurrentControlSet\Services\chvbd\Enum") -eq $false) {
            return $false
        }
        
        $out = Get-ItemProperty "HKLM:\SYSTEM\CurrentControlSet\Services\chvbd\Enum"      
        return $out.Count
}


function __extract_devid ([string] $str)
{
        
        $tmp = $str -replace '\s+', ' '
        return $tmp.Split(' ')[1].trim().ToString()
}


function __extract_partno ([string] $str)
{
       
        $tmp = $str -replace '\s+', ' '
        return $tmp.Split(' ')[1].trim().ToString()
}


function get_pci_device ([int] $num)
{
       
        $cmd = "cxgbtool.exe vbd$num version"
        $out = Invoke-Expression -Command $cmd
      
        for ($i=0; $i -le $out.Length-1; $i++){
               
                if ($out[$i].Contains("DeviceId:") -eq $true){
                        $dev_id = __extract_devid $out[$i]
                }

                if ($out[$i].Contains("S/N:") -eq $true){
                        $part = __extract_partno $out[$i]     
                }
        }
        
        return $dev_id, $part
}


function __is_t5 ([string] $device)
{
        foreach ( $key in ($device_map.GetEnumerator())){
                if ($device.Contains($key.name.ToLower())){
                    return $true, $key.value
            }
        }

}


function __add_device ([int] $vpd_count, [int]$count, [string] $name, [string] $part)
{
        $Global:__t5_cards.Add($vpd_count, $name)
        $Global:__t5_parts.Add($vpd_count, "S/N:" + $part)
        $Global:__t5_vpd_map.Add($vpd_count, $count)
        $Global:__t5_vpd_revmap.Add($count, $vpd_count)
}


function filter_t5 ([int] $count)
{
        $t5_count = 0
        for ($i=0; $i -le $count; $i++){
                $dev, $part = get_pci_device ($i)
                $st, $name = __is_t5 ($dev)
                if ($st -eq $true) {
                        __add_device $i $t5_count $name $part
                        $t5_count +=1
                }

        }
}

function choose_adapter ()
{
        Write-Host "`nSelect the Adapter"
        foreach ( $key in ($__t5_cards.GetEnumerator() | Sort-Object Name)){
                $cnt = [convert]::ToInt32($key.name, 10)              
                $display = $Global:__t5_vpd_map.Item($cnt) +1
                $tmp = "{0,7}{1,2}{2,1}{3,-15}{4,-18}" -f ` "", $display, ".", $key.value, $Global:__t5_parts.Item($cnt)
           
                Write-Host $tmp
        } 

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input to select adapter"
                exit (1)
        }

        if (-Not ($choice -ge 1 -and $choice -le  $__t5_cards.Count)){
                Write-Host "Please enter valid input to select adapter"
                exit (1)
        }

        return $Global:__t5_vpd_revmap.item($choice-1)


}

function choose_vpd()
{
        Write-Host "`nChoose the type:"
        Write-Host "`t1. DEFAULT (2 x 40G)"
        Write-Host "`t2. SPIDER  (4 x 10G)"
        Write-Host "`t3. QSA     (2 x 10G)"
        
        $adapter_name = $Global:__t5_cards.Item($adapter)  

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input !!"
                exit (1)
        }
        if ($choice -ne 1 -and $choice -ne 2 -and $choice -ne 3){
                Write-Host "Please enter valid input !!"
                exit(1)
        }
        return $choice
}


function is_t580([string] $adapter_name)
{
        if($adapter_name -eq "T580-LP-CR" -or $adapter_name -eq "T580-CR" -or $adapter_name -eq "T580-SO-CR"){
                return 1
        }
        return 0;

}

function choose_init ()
{
        Write-Host "`nChoose the configuration type:"
        Write-Host "`t1. NON-SRIOV (Default)"
        Write-Host "`t2. SRIOV"
        
        $adapter_name = $Global:__t5_cards.Item($adapter)
        if (is_t580($adapter_name)){
                Write-Host "`t3. Port settings"
        }

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input !!"
                exit (1)
        }
        if ($choice -ne 1 -and $choice -ne 2 -and $choice -ne 3){
                Write-Host "Please enter valid input !!"
                exit(1)
        }
        return $choice
}

function __yes_no_flash ()
{
        $choice = Read-Host "Do you want to continue (y/n)"

        Set-Content tmp $choice
        if ($choice  -eq 'y' -or $choice -eq 'Y'){
                return $true
        }
        if ($choice -ne 'n' -and $choice -ne 'N'){
                Write-Host "Invalid input!"
        }
        
        Remove-Item tmp
        exit(1)
}
    
function __flash ($vpd, $path)
{     
        $out = __verify $vpd $path $false
        if ( ($out -join '`n').Contains("FAILED") -eq $false) {
                Write-Host "`nThe selected configuration is already present." -ForegroundColor Green
                exit(0)
        }

        $out = [string]

        # Exit if the user says not to flash
        $choice = __yes_no_flash 
 
        $path = "`"$path`""
        # Start the process and attact the user input as the
        # standard input file. 
        Start-Process cxgbtool.exe -ArgumentList vbd$vpd,serialinit,write,$path -RedirectStandardInput tmp -RedirectStandardOutput out0 -Wait -NoNewWindow

        $out = Get-Content out0
        #Write-Host `n

        Remove-Item tmp
        Remove-Item out0

        if ( ($out -join '`n').Contains('fail') -eq $true){
                Write-Host "Flashing failed with error `n $out" -ForegroundColor Red
                exit(1)
        }
       
}

function __flash_vpd ($vpd, $path)
{     
        $out = __verify_vpd $vpd $path $false
        if ( ($out -join '`n').Contains("FAILED") -eq $false) {
                Write-Host "`nThe selected configuration is already present." -ForegroundColor Green
                exit(0)
        }

        $out = [string]

        # Exit if the user says not to flash
        $choice = __yes_no_flash 
 
        $path = "`"$path`""
        # Start the process and attact the user input as the
        # standard input file. 
        Start-Process cxgbtool.exe -ArgumentList vbd$vpd,vpd,write,$path -RedirectStandardInput tmp -RedirectStandardOutput out0 -Wait -NoNewWindow

        $out = Get-Content out0
        
        Remove-Item tmp
        Remove-Item out0

        if ( ($out -join '`n').Contains('fail') -eq $true){
                Write-Host "Flashing failed with error `n $out" -ForegroundColor Red
                exit(1)
        }
       
}

function __verify_vpd ($vpd, $path, $debug)
{
      
        #if ( $debug -eq $true){
        #        Write-Host -NoNewline "`nVerifying the existing configuration... " -ForegroundColor Green
        #}

        $cmd = "cxgbtool.exe vbd$vpd vpd verify `"$path`""
        
        $out = Invoke-Expression -Command $cmd 
       
        return $out

}


function __verify ($vpd, $path, $debug)
{
      
        #if ( $debug -eq $true){
        #        Write-Host -NoNewline "`nVerifying the existing configuration... " -ForegroundColor Green
        #}

        $cmd = "cxgbtool.exe vbd$vpd serialinit verify `"$path`""
        $out = Invoke-Expression -Command $cmd 
        #Write-Host $cmd
        return $out

}

function __get_default_init ([string] $adapter_name)
{
        $file_name = $Global:__default_init.Item($adapter_name)
        if ( (Test-Path  "$Global:__sys_drive\ChelsioT4\Adapter Configuration\default\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioT4\Adapter` Configuration\default\$file_name"
        }
        elseif ( (Test-Path ".\default\$file_name") -eq $true){
                return  ".\default\$file_name"
        }
        else {
                return $file_name
        }
}


function __get_sriov  ([string] $adapter_name)
{

        $file_name = $Global:__sriov.Item($adapter_name)

        if ( (Test-Path "$Global:__sys_drive\ChelsioT4\Adapter Configuration\SRIOV\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioT4\Adapter` Configuration\SRIOV\$file_name"
        }
        elseif ( (Test-Path ".\SRIOV\$file_name") -eq $true){
                return  ".\SRIOV\$file_name"
        }
        else {
                return $file_name
        }
}

 
function __check_init_path ($path)
{
        $ret = Test-Path $path 
        if ($ret -eq $false){
                Write-Host "Unable to find the bin file." -ForegroundColor Red
                exit (1)
        }

}

function __get_vpd([string] $adapter_name, [int] $vpd_choice)
{

        if ($vpd_choice -eq 1){
                $file_name = $Global:__vpd_default.Item($adapter_name)
                                
        }
        elseif ($vpd_choice -eq 2){
                 $file_name = $Global:__vpd_spider.Item($adapter_name)
        }
        elseif ($vpd_choice -eq 3){
                 $file_name = $Global:__vpd_qsa.Item($adapter_name)
        }

        if ( (Test-Path "$Global:__sys_drive\ChelsioT4\Adapter Configuration\Port Settings\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioT4\Adapter` Configuration\Port` Settings\$file_name"
        }
        elseif ( (Test-Path ".\Port Settings\$file_name") -eq $true){
                return  ".\Port` Settings\$file_name"
        }
        else {
                return $file_name
        }
}

function flash ([int] $adapter, [int] $init)
{
        $adapter_name = $Global:__t5_cards.Item($adapter)
        $t5 = is_t580 $adapter_name
        
        if ($init -eq 1){
                $init_file = __get_default_init ($adapter_name)    
        }elseif ($init -eq 2){
                $init_file = __get_sriov ($adapter_name)
                #Write-Host "adap $adapter_name"
                #Write-Host "sriov init $init_file"
                
        }elseif ($init -eq 3 -and $t5){
                $vpd_choice = choose_vpd
                $init_file = __get_vpd $adapter_name $vpd_choice            

        }else {
                Write-Host "Please Enter valid input !!!"
                exit(1)
        }

        __check_init_path ($init_file)
        
        if ($init -eq 3){
                __flash_vpd $adapter $init_file
                $out = __verify_vpd $adapter $init_file $true
        }else {
                __flash $adapter $init_file
                $out = __verify $adapter $init_file $true
        }
        
        #Write-Host $out
        if (($out -join '`n').Contains("FAILED")) {
                #Write-Host $out
                Write-Host "`nVerification Failed." -ForegroundColor Red
                exit(1)
        }
        else {
                Write-Host "Successfully updated the selected configuration type." -ForegroundColor Green
                Write-Host "`nVerification: Passed" -ForegroundColor Green
                Write-Host "`nPlease reboot the machine for changes to take effect." -ForegroundColor Red
        }
}

function main (){
        if ((is_cxgbtool_present ) -eq $false){
                Write-Host "cxgbtool is not present in system32 folder." -ForegroundColor Red
                exit(1)
        }
        Write-Host "`nchelsio_adapter_config Version $Global:__version__`n"
        Write-Host "Please stop all the traffic on Chelsio adapters before updating !!" -ForegroundColor Red
        $count = get_t5_count
        filter_t5 ($count)
        $adapter = choose_adapter
        $init = choose_init
 
        flash $adapter $init
}

main 

# SIG # Begin signature block
# MIId0gYJKoZIhvcNAQcCoIIdwzCCHb8CAQExCzAJBgUrDgMCGgUAMGkGCisGAQQB
# gjcCAQSgWzBZMDQGCisGAQQBgjcCAR4wJgIDAQAABBAfzDtgWUsITrck0sYpfvNR
# AgEAAgEAAgEAAgEAAgEAMCEwCQYFKw4DAhoFAAQU5inOwf7rjieIkn6Oe6jKwNWf
# 5/WgghjGMIIFdTCCBF2gAwIBAgIQULHtLPXTjcKVU9ADmUPJiDANBgkqhkiG9w0B
# AQUFADCBtDELMAkGA1UEBhMCVVMxFzAVBgNVBAoTDlZlcmlTaWduLCBJbmMuMR8w
# HQYDVQQLExZWZXJpU2lnbiBUcnVzdCBOZXR3b3JrMTswOQYDVQQLEzJUZXJtcyBv
# ZiB1c2UgYXQgaHR0cHM6Ly93d3cudmVyaXNpZ24uY29tL3JwYSAoYykxMDEuMCwG
# A1UEAxMlVmVyaVNpZ24gQ2xhc3MgMyBDb2RlIFNpZ25pbmcgMjAxMCBDQTAeFw0x
# MzEwMTUwMDAwMDBaFw0xNjExMTMyMzU5NTlaMIG4MQswCQYDVQQGEwJVUzETMBEG
# A1UECBMKQ2FsaWZvcm5pYTESMBAGA1UEBxMJU3Vubnl2YWxlMR8wHQYDVQQKFBZD
# aGVsc2lvIENvbW11bmljYXRpb25zMT4wPAYDVQQLEzVEaWdpdGFsIElEIENsYXNz
# IDMgLSBNaWNyb3NvZnQgU29mdHdhcmUgVmFsaWRhdGlvbiB2MjEfMB0GA1UEAxQW
# Q2hlbHNpbyBDb21tdW5pY2F0aW9uczCCASIwDQYJKoZIhvcNAQEBBQADggEPADCC
# AQoCggEBAI85tARD0r6smneXddzxE3JlcAVQM7qMRk4A31EzxRGhCz6/mmAeCe4B
# wZDZOHXkVAD4mne1p+ZOINQg/wGMHqV7tQvhQvahOgFHzlwDrjMuoUVkuJzzwOwx
# p5rHnERfWdkx7TakdOXv+qvGqUAWo9bR5JJrhB4triXfkA/z+0f27rSpoNunNwDF
# CEWytN/obZSIe0FJUpDPKDOXchrif/nbLC0gReWAE7tpUP8wNMf1IVmAVkpCcY0O
# 5Oq/DC6WKi8jvxKB11KOEuYZ1Tb3GsJTBt+iqADH/PXNUsPtAWCsIx70YyijvsE7
# +UmI+axtE2wyJNtl0e9ndPMBrxLJ3RECAwEAAaOCAXswggF3MAkGA1UdEwQCMAAw
# DgYDVR0PAQH/BAQDAgeAMEAGA1UdHwQ5MDcwNaAzoDGGL2h0dHA6Ly9jc2MzLTIw
# MTAtY3JsLnZlcmlzaWduLmNvbS9DU0MzLTIwMTAuY3JsMEQGA1UdIAQ9MDswOQYL
# YIZIAYb4RQEHFwMwKjAoBggrBgEFBQcCARYcaHR0cHM6Ly93d3cudmVyaXNpZ24u
# Y29tL3JwYTATBgNVHSUEDDAKBggrBgEFBQcDAzBxBggrBgEFBQcBAQRlMGMwJAYI
# KwYBBQUHMAGGGGh0dHA6Ly9vY3NwLnZlcmlzaWduLmNvbTA7BggrBgEFBQcwAoYv
# aHR0cDovL2NzYzMtMjAxMC1haWEudmVyaXNpZ24uY29tL0NTQzMtMjAxMC5jZXIw
# HwYDVR0jBBgwFoAUz5mp6nsm9EvJjo/X8AUm7+PSp50wEQYJYIZIAYb4QgEBBAQD
# AgQQMBYGCisGAQQBgjcCARsECDAGAQEAAQH/MA0GCSqGSIb3DQEBBQUAA4IBAQDl
# WOSi+XhUXKCvskAAu0frqBCEujgf/V+2+q+kNQMNKuinNH4eQecGnIwV6jx5loAA
# uH9NonJuWXnRai4bF/MR5dBPg+wjThnROVEInllH7W8ZQBr6AqMq12VjmRiwK4iJ
# oz+mdgLpozwU74eBD4WPkuKhQw3b3I8JYn94cgBURb4t42WrkFjCdJ3lnzFuLrNw
# zcq0jUOv0bPeLygd+mww3U2s0LdxQCz5A5WFRZ9anQ4/ZMH2lZVz3Mha1GQL/wZm
# 5+X294MWZsvXY53j+hIl3CaoC2O3Q69APbuA7jSzNGcpfO/1KlWiLPe80v0n+FTd
# lG4Jm+leLhm/hlKOxiwUMIIGCjCCBPKgAwIBAgIQUgDlqiVW/BqG7ZbJ1EszxzAN
# BgkqhkiG9w0BAQUFADCByjELMAkGA1UEBhMCVVMxFzAVBgNVBAoTDlZlcmlTaWdu
# LCBJbmMuMR8wHQYDVQQLExZWZXJpU2lnbiBUcnVzdCBOZXR3b3JrMTowOAYDVQQL
# EzEoYykgMjAwNiBWZXJpU2lnbiwgSW5jLiAtIEZvciBhdXRob3JpemVkIHVzZSBv
# bmx5MUUwQwYDVQQDEzxWZXJpU2lnbiBDbGFzcyAzIFB1YmxpYyBQcmltYXJ5IENl
# cnRpZmljYXRpb24gQXV0aG9yaXR5IC0gRzUwHhcNMTAwMjA4MDAwMDAwWhcNMjAw
# MjA3MjM1OTU5WjCBtDELMAkGA1UEBhMCVVMxFzAVBgNVBAoTDlZlcmlTaWduLCBJ
# bmMuMR8wHQYDVQQLExZWZXJpU2lnbiBUcnVzdCBOZXR3b3JrMTswOQYDVQQLEzJU
# ZXJtcyBvZiB1c2UgYXQgaHR0cHM6Ly93d3cudmVyaXNpZ24uY29tL3JwYSAoYykx
# MDEuMCwGA1UEAxMlVmVyaVNpZ24gQ2xhc3MgMyBDb2RlIFNpZ25pbmcgMjAxMCBD
# QTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAPUjS16l14q7MunUV/fv
# 5Mcmfq0ZmP6onX2U9jZrENd1gTB/BGh/yyt1Hs0dCIzfaZSnN6Oce4DgmeHuN01f
# zjsU7obU0PUnNbwlCzinjGOdF6MIpauw+81qYoJM1SHaG9nx44Q7iipPhVuQAU/J
# p3YQfycDfL6ufn3B3fkFvBtInGnnwKQ8PEEAPt+W5cXklHHWVQHHACZKQDy1oSap
# DKdtgI6QJXvPvz8c6y+W+uWHd8a1VrJ6O1QwUxvfYjT/HtH0WpMoheVMF05+W/2k
# k5l/383vpHXv7xX2R+f4GXLYLjQaprSnTH69u08MPVfxMNamNo7WgHbXGS6lzX40
# LYkCAwEAAaOCAf4wggH6MBIGA1UdEwEB/wQIMAYBAf8CAQAwcAYDVR0gBGkwZzBl
# BgtghkgBhvhFAQcXAzBWMCgGCCsGAQUFBwIBFhxodHRwczovL3d3dy52ZXJpc2ln
# bi5jb20vY3BzMCoGCCsGAQUFBwICMB4aHGh0dHBzOi8vd3d3LnZlcmlzaWduLmNv
# bS9ycGEwDgYDVR0PAQH/BAQDAgEGMG0GCCsGAQUFBwEMBGEwX6FdoFswWTBXMFUW
# CWltYWdlL2dpZjAhMB8wBwYFKw4DAhoEFI/l0xqGrI2Oa8PPgGrUSBgsexkuMCUW
# I2h0dHA6Ly9sb2dvLnZlcmlzaWduLmNvbS92c2xvZ28uZ2lmMDQGA1UdHwQtMCsw
# KaAnoCWGI2h0dHA6Ly9jcmwudmVyaXNpZ24uY29tL3BjYTMtZzUuY3JsMDQGCCsG
# AQUFBwEBBCgwJjAkBggrBgEFBQcwAYYYaHR0cDovL29jc3AudmVyaXNpZ24uY29t
# MB0GA1UdJQQWMBQGCCsGAQUFBwMCBggrBgEFBQcDAzAoBgNVHREEITAfpB0wGzEZ
# MBcGA1UEAxMQVmVyaVNpZ25NUEtJLTItODAdBgNVHQ4EFgQUz5mp6nsm9EvJjo/X
# 8AUm7+PSp50wHwYDVR0jBBgwFoAUf9Nlp8Ld7LvwMAnzQzn6Aq8zMTMwDQYJKoZI
# hvcNAQEFBQADggEBAFYi5jSkxGHLSLkBrVaoZA/ZjJHEu8wM5a16oCJ/30c4Si1s
# 0X9xGnzscKmx8E/kDwxT+hVe/nSYSSSFgSYckRRHsExjjLuhNNTGRegNhSZzA9Cp
# jGRt3HGS5kUFYBVZUTn8WBRr/tSk7XlrCAxBcuc3IgYJviPpP0SaHulhncyxkFz8
# PdKNrEI9ZTbUtD1AKI+bEM8jJsxLIMuQH12MTDTKPNjlN9ZvpSC9NOsm2a4N58Wa
# 96G0IZEzb4boWLslfHQOWP51G2M/zjF8m48blp7FU3aEW5ytkfqs7ZO6XcghU8KC
# U2OvEg1QhxEbPVRSloosnD2SGgiaBS7Hk6VIkdMwggZqMIIFUqADAgECAhADAZoC
# Ov9YsWvW1ermF/BmMA0GCSqGSIb3DQEBBQUAMGIxCzAJBgNVBAYTAlVTMRUwEwYD
# VQQKEwxEaWdpQ2VydCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5jb20xITAf
# BgNVBAMTGERpZ2lDZXJ0IEFzc3VyZWQgSUQgQ0EtMTAeFw0xNDEwMjIwMDAwMDBa
# Fw0yNDEwMjIwMDAwMDBaMEcxCzAJBgNVBAYTAlVTMREwDwYDVQQKEwhEaWdpQ2Vy
# dDElMCMGA1UEAxMcRGlnaUNlcnQgVGltZXN0YW1wIFJlc3BvbmRlcjCCASIwDQYJ
# KoZIhvcNAQEBBQADggEPADCCAQoCggEBAKNkXfx8s+CCNeDg9sYq5kl1O8xu4FOp
# nx9kWeZ8a39rjJ1V+JLjntVaY1sCSVDZg85vZu7dy4XpX6X51Id0iEQ7Gcnl9ZGf
# xhQ5rCTqqEsskYnMXij0ZLZQt/USs3OWCmejvmGfrvP9Enh1DqZbFP1FI46GRFV9
# GIYFjFWHeUhG98oOjafeTl/iqLYtWQJhiGFyGGi5uHzu5uc0LzF3gTAfuzYBje8n
# 4/ea8EwxZI3j6/oZh6h+z+yMDDZbesF6uHjHyQYuRhDIjegEYNu8c3T6Ttj+qkDx
# ss5wRoPp2kChWTrZFQlXmVYwk/PJYczQCMxr7GJCkawCwO+k8IkRj3cCAwEAAaOC
# AzUwggMxMA4GA1UdDwEB/wQEAwIHgDAMBgNVHRMBAf8EAjAAMBYGA1UdJQEB/wQM
# MAoGCCsGAQUFBwMIMIIBvwYDVR0gBIIBtjCCAbIwggGhBglghkgBhv1sBwEwggGS
# MCgGCCsGAQUFBwIBFhxodHRwczovL3d3dy5kaWdpY2VydC5jb20vQ1BTMIIBZAYI
# KwYBBQUHAgIwggFWHoIBUgBBAG4AeQAgAHUAcwBlACAAbwBmACAAdABoAGkAcwAg
# AEMAZQByAHQAaQBmAGkAYwBhAHQAZQAgAGMAbwBuAHMAdABpAHQAdQB0AGUAcwAg
# AGEAYwBjAGUAcAB0AGEAbgBjAGUAIABvAGYAIAB0AGgAZQAgAEQAaQBnAGkAQwBl
# AHIAdAAgAEMAUAAvAEMAUABTACAAYQBuAGQAIAB0AGgAZQAgAFIAZQBsAHkAaQBu
# AGcAIABQAGEAcgB0AHkAIABBAGcAcgBlAGUAbQBlAG4AdAAgAHcAaABpAGMAaAAg
# AGwAaQBtAGkAdAAgAGwAaQBhAGIAaQBsAGkAdAB5ACAAYQBuAGQAIABhAHIAZQAg
# AGkAbgBjAG8AcgBwAG8AcgBhAHQAZQBkACAAaABlAHIAZQBpAG4AIABiAHkAIABy
# AGUAZgBlAHIAZQBuAGMAZQAuMAsGCWCGSAGG/WwDFTAfBgNVHSMEGDAWgBQVABIr
# E5iymQftHt+ivlcNK2cCzTAdBgNVHQ4EFgQUYVpNJLZJMp1KKnkag0v0HonByn0w
# fQYDVR0fBHYwdDA4oDagNIYyaHR0cDovL2NybDMuZGlnaWNlcnQuY29tL0RpZ2lD
# ZXJ0QXNzdXJlZElEQ0EtMS5jcmwwOKA2oDSGMmh0dHA6Ly9jcmw0LmRpZ2ljZXJ0
# LmNvbS9EaWdpQ2VydEFzc3VyZWRJRENBLTEuY3JsMHcGCCsGAQUFBwEBBGswaTAk
# BggrBgEFBQcwAYYYaHR0cDovL29jc3AuZGlnaWNlcnQuY29tMEEGCCsGAQUFBzAC
# hjVodHRwOi8vY2FjZXJ0cy5kaWdpY2VydC5jb20vRGlnaUNlcnRBc3N1cmVkSURD
# QS0xLmNydDANBgkqhkiG9w0BAQUFAAOCAQEAnSV+GzNNsiaBXJuGziMgD4CH5Yj/
# /7HUaiwx7ToXGXEXzakbvFoWOQCd42yE5FpA+94GAYw3+puxnSR+/iCkV61bt5qw
# YCbqaVchXTQvH3Gwg5QZBWs1kBCge5fH9j/n4hFBpr1i2fAnPTgdKG86Ugnw7HBi
# 02JLsOBzppLA044x2C/jbRcTBu7kA7YUq/OPQ6dxnSHdFMoVXZJB2vkPgdGZdA0m
# xA5/G7X1oPHGdwYoFenYk+VVFvC7Cqsc21xIJ2bIo4sKHOWV2q7ELlmgYd3a822i
# YemKC23sEhi991VUQAOSK2vCUcIKSK+w1G7g9BQKOhvjjz3Kr2qNe9zYRDCCBs0w
# ggW1oAMCAQICEAb9+QOWA63qAArrPye7uhswDQYJKoZIhvcNAQEFBQAwZTELMAkG
# A1UEBhMCVVMxFTATBgNVBAoTDERpZ2lDZXJ0IEluYzEZMBcGA1UECxMQd3d3LmRp
# Z2ljZXJ0LmNvbTEkMCIGA1UEAxMbRGlnaUNlcnQgQXNzdXJlZCBJRCBSb290IENB
# MB4XDTA2MTExMDAwMDAwMFoXDTIxMTExMDAwMDAwMFowYjELMAkGA1UEBhMCVVMx
# FTATBgNVBAoTDERpZ2lDZXJ0IEluYzEZMBcGA1UECxMQd3d3LmRpZ2ljZXJ0LmNv
# bTEhMB8GA1UEAxMYRGlnaUNlcnQgQXNzdXJlZCBJRCBDQS0xMIIBIjANBgkqhkiG
# 9w0BAQEFAAOCAQ8AMIIBCgKCAQEA6IItmfnKwkKVpYBzQHDSnlZUXKnE0kEGj8kz
# /E1FkVyBn+0snPgWWd+etSQVwpi5tHdJ3InECtqvy15r7a2wcTHrzzpADEZNk+yL
# ejYIA6sMNP4YSYL+x8cxSIB8HqIPkg5QycaH6zY/2DDD/6b3+6LNb3Mj/qxWBZDw
# MiEWicZwiPkFl32jx0PdAug7Pe2xQaPtP77blUjE7h6z8rwMK5nQxl0SQoHhg26C
# cz8mSxSQrllmCsSNvtLOBq6thG9IhJtPQLnxTPKvmPv2zkBdXPao8S+v7Iki8msY
# ZbHBc63X8djPHgp0XEK4aH631XcKJ1Z8D2KkPzIUYJX9BwSiCQIDAQABo4IDejCC
# A3YwDgYDVR0PAQH/BAQDAgGGMDsGA1UdJQQ0MDIGCCsGAQUFBwMBBggrBgEFBQcD
# AgYIKwYBBQUHAwMGCCsGAQUFBwMEBggrBgEFBQcDCDCCAdIGA1UdIASCAckwggHF
# MIIBtAYKYIZIAYb9bAABBDCCAaQwOgYIKwYBBQUHAgEWLmh0dHA6Ly93d3cuZGln
# aWNlcnQuY29tL3NzbC1jcHMtcmVwb3NpdG9yeS5odG0wggFkBggrBgEFBQcCAjCC
# AVYeggFSAEEAbgB5ACAAdQBzAGUAIABvAGYAIAB0AGgAaQBzACAAQwBlAHIAdABp
# AGYAaQBjAGEAdABlACAAYwBvAG4AcwB0AGkAdAB1AHQAZQBzACAAYQBjAGMAZQBw
# AHQAYQBuAGMAZQAgAG8AZgAgAHQAaABlACAARABpAGcAaQBDAGUAcgB0ACAAQwBQ
# AC8AQwBQAFMAIABhAG4AZAAgAHQAaABlACAAUgBlAGwAeQBpAG4AZwAgAFAAYQBy
# AHQAeQAgAEEAZwByAGUAZQBtAGUAbgB0ACAAdwBoAGkAYwBoACAAbABpAG0AaQB0
# ACAAbABpAGEAYgBpAGwAaQB0AHkAIABhAG4AZAAgAGEAcgBlACAAaQBuAGMAbwBy
# AHAAbwByAGEAdABlAGQAIABoAGUAcgBlAGkAbgAgAGIAeQAgAHIAZQBmAGUAcgBl
# AG4AYwBlAC4wCwYJYIZIAYb9bAMVMBIGA1UdEwEB/wQIMAYBAf8CAQAweQYIKwYB
# BQUHAQEEbTBrMCQGCCsGAQUFBzABhhhodHRwOi8vb2NzcC5kaWdpY2VydC5jb20w
# QwYIKwYBBQUHMAKGN2h0dHA6Ly9jYWNlcnRzLmRpZ2ljZXJ0LmNvbS9EaWdpQ2Vy
# dEFzc3VyZWRJRFJvb3RDQS5jcnQwgYEGA1UdHwR6MHgwOqA4oDaGNGh0dHA6Ly9j
# cmwzLmRpZ2ljZXJ0LmNvbS9EaWdpQ2VydEFzc3VyZWRJRFJvb3RDQS5jcmwwOqA4
# oDaGNGh0dHA6Ly9jcmw0LmRpZ2ljZXJ0LmNvbS9EaWdpQ2VydEFzc3VyZWRJRFJv
# b3RDQS5jcmwwHQYDVR0OBBYEFBUAEisTmLKZB+0e36K+Vw0rZwLNMB8GA1UdIwQY
# MBaAFEXroq/0ksuCMS1Ri6enIZ3zbcgPMA0GCSqGSIb3DQEBBQUAA4IBAQBGUD7J
# tygkpzgdtlspr1LPUukxR6tWXHvVDQtBs+/sdR90OPKyXGGinJXDUOSCuSPRujqG
# cq04eKx1XRcXNHJHhZRW0eu7NoR3zCSl8wQZVann4+erYs37iy2QwsDStZS9Xk+x
# BdIOPRqpFFumhjFiqKgz5Js5p8T1zh14dpQlc+Qqq8+cdkvtX8JLFuRLcEwAiR78
# xXm8TBJX/l/hHrwCXaj++wc4Tw3GXZG5D2dFzdaD7eeSDY2xaYxP+1ngIw/Sqq4A
# fO6cQg7PkdcntxbuD8O9fAqg7iwIVYUiuOsYGk38KiGtSTGDR5V3cdyxG0tLHBCc
# dxTBnU8vWpUIKRAmMYIEdjCCBHICAQEwgckwgbQxCzAJBgNVBAYTAlVTMRcwFQYD
# VQQKEw5WZXJpU2lnbiwgSW5jLjEfMB0GA1UECxMWVmVyaVNpZ24gVHJ1c3QgTmV0
# d29yazE7MDkGA1UECxMyVGVybXMgb2YgdXNlIGF0IGh0dHBzOi8vd3d3LnZlcmlz
# aWduLmNvbS9ycGEgKGMpMTAxLjAsBgNVBAMTJVZlcmlTaWduIENsYXNzIDMgQ29k
# ZSBTaWduaW5nIDIwMTAgQ0ECEFCx7Sz1043ClVPQA5lDyYgwCQYFKw4DAhoFAKBw
# MBAGCisGAQQBgjcCAQwxAjAAMBkGCSqGSIb3DQEJAzEMBgorBgEEAYI3AgEEMBwG
# CisGAQQBgjcCAQsxDjAMBgorBgEEAYI3AgEVMCMGCSqGSIb3DQEJBDEWBBSXjx12
# bqv5HwHnGc5mwDiz4TuGZDANBgkqhkiG9w0BAQEFAASCAQCONNgS+09RB6QXcD1i
# qSpxoe5pPcKjdeXOku0VE8QiQkurw0WGWI6ENOb2M1N5NtwEkvVwkm6WVF4VqKhT
# 7/2MM2oTrCVCgW3O58aTsB9GAkKKyHVcVngHFt2ltcqCYmjqowmSF4cP3L9Hj9qt
# 2fMz9NL+vWQxOHo8K/zEGd8BXeffwMR9DG+miTs9fsxMNEQ1peEg3AVb+uQjf7jh
# 7gTxNOHA/sgeotVACUQamFV4Y4FNXY0Z25US9ENd/aOSYvwQAS+nGtwozirz96SU
# +rhZYpCuWxjPMhs48Q1sdvWf860SHx+JsptvPnfCn2QhBJbR3lDA2hfer3djCVcn
# NHd8oYICDzCCAgsGCSqGSIb3DQEJBjGCAfwwggH4AgEBMHYwYjELMAkGA1UEBhMC
# VVMxFTATBgNVBAoTDERpZ2lDZXJ0IEluYzEZMBcGA1UECxMQd3d3LmRpZ2ljZXJ0
# LmNvbTEhMB8GA1UEAxMYRGlnaUNlcnQgQXNzdXJlZCBJRCBDQS0xAhADAZoCOv9Y
# sWvW1ermF/BmMAkGBSsOAwIaBQCgXTAYBgkqhkiG9w0BCQMxCwYJKoZIhvcNAQcB
# MBwGCSqGSIb3DQEJBTEPFw0xNTEwMzAxMjE1MTZaMCMGCSqGSIb3DQEJBDEWBBTC
# oAtY3SJNDikK81K7J06TScB4IzANBgkqhkiG9w0BAQEFAASCAQBBcAvzRUc8/0vv
# adm6Ef6/FlO1l61a7VP0+6TqNYORe0ypHPesz+5wkWYvc+c0oRV2SHj7oSPmpuJS
# zXXsz6tXPT5jCVTHRMmbeKIcLGjsAld31exZAPI7gUMHZpSz/r5QMoCfQKuP+f41
# lkWeylO9gTSWpd/ZtmwIBOQm4LAMNAH0rA8nNb74geU2cjJkKd6uFLMwBvyjIyrU
# EmVLRAHkE0fs7NhcCeQ894ZAf8usqr563j80SH5JFImfg9L6GWQ/T9Q2taYad1sM
# lr1rN7ufuH5ZQET5DA2uofR3Cw7NxTg/DCCEW/IkVyrMjmquPXVfQVrqmEf4PVxy
# 9qQfzIfM
# SIG # End signature block
